Bug 457936 - Underquoted # in tests/run.src/extensions.at
Underquoted # in tests/run.src/extensions.at
Product: Fedora
Classification: Fedora
Component: open-cobol (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jochen Schmitt
Fedora Extras Quality Assurance
Depends On:
Blocks: 457261
  Show dependency treegraph
Reported: 2008-08-05 12:17 EDT by Jochen Schmitt
Modified: 2010-12-05 02:09 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2010-12-05 02:09:13 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Jochen Schmitt 2008-08-05 12:17:26 EDT
Description of problem:

when I try to modify the file tests/run.src/exntensions.at in the open-cobol package, I will get the following error messages:

make[4]: Entering directory
autom4te --language=autotest -I . -I ./run.src -o run run.at
./run.src/extensions.at:423: error: m4_divert_pop(TEST_SCRIPT):
diversion mismatch:
./run.src/extensions.at:416: m4_divert_push: GROW
./run.src/extensions.at:374: m4_divert_push: TEST_SCRIPT
./run.src/extensions.at:374: m4_divert_push: TEST_GROUPS
run.at:21: m4_divert_push: KILL
../../lib/m4sugar/m4sh.m4:797: AS_ECHO is expanded from...
./run.src/extensions.at:423: the top level
autom4te: /usr/bin/m4 failed with exit status: 1
make[4]: *** [run] Fehler 1
make[4]: Leaving directory
make[3]: *** [check-am] Fehler 2

Version-Release number of selected component (if applicable):


How reproducible:

Download open-cobol from BZ #457261 and build it.

After this going in the builddir and touch tests/run.src/extensions.at

I you type 'make check' now, you will get the error messages cite above.

Actual results:

Test suite will not executed

Expected results:

Test suite should be execute.

Additional info:

This issue occured only with autoconf-2.62.
Comment 1 Bug Zapper 2008-11-25 21:40:04 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
Comment 2 Stepan Kasal 2009-11-02 09:36:05 EST
This is not a bug in autotest, but a problem in the .at source.

Re-assigning to open-cobol.

I have verified that it is still present in latest release in Fedora rawhide, open-cobol-1.1

The problem is caused by characters `#' between lines 401 and 450 of file tests/run.src/exntensions.at .

In m4 in autotest, # is declared as the comment character, menaing that whenever it is encountered, the rest of the line is not subject to m4 macro expansion.
That implies that whenever # is contained in a literal text, it should be properly quoted, so that m4 does not "see" the hash while expanding.

The solution is to double quote the literal arguments, like this:

AT_DATA([[A#B.cob]], [[
       PROGRAM-ID.      "A#B".
           EXIT PROGRAM.


Let me remind you that m4 may expand macro arguments twice:
- first, m4 expands the text between the parentheses while scanning the argument list
- second, after the macro call is replaced by the body with parameters substituted, that body is expanded.

Because in most cases it is desirable that arguments are expanded only once, they are quoted in [ ], so that the parameter scanning phase does not do any expansion.

But in cases like this, when the parameter is actually a literal text, that should never be subject to m4 expansion, it is more adequate to double quote, i.e. use two pairs of brackets: the first pair is removed during the argument scanning phase, the second one is removed while the macro body is being expanded.

For details, see:
and the neighbour parts of the GNU Autoconf manual, or the GNU M4 manual available at http://www.gnu.org/software/m4/manual/
Or feel free to ask me for help.
Comment 3 Bug Zapper 2009-11-16 03:10:47 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
Comment 4 Bug Zapper 2010-11-04 07:49:31 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 5 Bug Zapper 2010-12-05 02:09:13 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.